Page MenuHomePhabricator

[DebugInfo] Enable call site parameter debug info for ARM and AArch64
ClosedPublic

Authored by NikolaPrica on Aug 30 2019, 7:12 AM.

Details

Summary

ARM and AArch64 SelectionDAG support for tacking parameter forwarding register is implemented so we can allow clang invocations for those two targets.
Beside that restrict debug entry value support to be emitted for LimitedDebugInfo info and FullDebugInfo. Other types of debug info do not have functions nor variables debug info.

Diff Detail

Event Timeline

NikolaPrica created this revision.Aug 30 2019, 7:12 AM
vsk added a comment.Aug 30 2019, 9:16 AM

Update test/CodeGen/debug-info-param-modification.c?

lib/Frontend/CompilerInvocation.cpp
784 ↗(On Diff #218086)

This helper would be easier to read as an out-of-line function, imo.

dstenb added inline comments.Aug 30 2019, 11:57 AM
lib/Frontend/CompilerInvocation.cpp
784 ↗(On Diff #218086)

Or perhaps something like this?

const llvm::Triple::ArchType DebugEntryValueArchs[] = {llvm::Triple::x86, [...]};

llvm::is_contained(DebugEntryValueArchs, Arch)

Addressing comments.
Thanks for suggestions!

aprantl added inline comments.Sep 3 2019, 9:04 AM
lib/Frontend/CompilerInvocation.cpp
784 ↗(On Diff #218086)

I suppose this is fine, but it would be more elegant if we could query the target whether it supports entry values.

NikolaPrica marked an inline comment as done.Sep 6 2019, 4:46 AM
NikolaPrica added inline comments.
lib/Frontend/CompilerInvocation.cpp
784 ↗(On Diff #218086)

At this point target has not been initialized yet. I considered adding such support to TargetMachine or LLVMTargetMachine but then we would need to reset this option later at some point when this object is initialized.

NikolaPrica marked an inline comment as not done.Sep 11 2019, 8:56 AM

Ping.

vsk accepted this revision.Sep 11 2019, 10:08 AM

Lgtm, sorry for the delay.

This revision is now accepted and ready to land.Sep 11 2019, 10:08 AM
This revision was automatically updated to reflect the committed changes.
Herald added a project: Restricted Project. · View Herald TranscriptWed, Oct 9, 3:14 AM
Herald added a subscriber: cfe-commits. · View Herald Transcript